config/routes.rb
Rails.application.routes.draw do
  root to: "home#index"
  resources :artefacts
  resources :tasks
  resources :bpmn_processes
  get :uploads, :controller => :uploads, :action => :index
  get :report, to: 'report#index', as: :report
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/artefact.rb
class Artefact < ApplicationRecord
  belongs_to :task
end

app/controllers/artefacts_controller.rb
class ArtefactsController < ApplicationController
  before_action :set_artefact, only: [:show, :edit, :update, :destroy]

  # GET /artefacts
  # GET /artefacts.json
  def index
    @artefacts = Artefact.all
  end

  # GET /artefacts/1
  # GET /artefacts/1.json
  def show
  end

  # GET /artefacts/new
  def new
    @artefact = Artefact.new
  end

  # GET /artefacts/1/edit
  def edit
  end

  # POST /artefacts
  # POST /artefacts.json
  def create
    @artefact = Artefact.new(artefact_params)

    respond_to do |format|
      if @artefact.save
        format.html { redirect_to @artefact, notice: 'Artefact was successfully created.' }
        format.json { render :show, status: :created, location: @artefact }
      else
        format.html { render :new }
        format.json { render json: @artefact.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /artefacts/1
  # PATCH/PUT /artefacts/1.json
  def update
    respond_to do |format|
      if @artefact.update(artefact_params)
        format.html { redirect_to @artefact, notice: 'Artefact was successfully updated.' }
        format.json { render :show, status: :ok, location: @artefact }
      else
        format.html { render :edit }
        format.json { render json: @artefact.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /artefacts/1
  # DELETE /artefacts/1.json
  def destroy
    @artefact.destroy
    respond_to do |format|
      format.html { redirect_to artefacts_url, notice: 'Artefact was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_artefact
      @artefact = Artefact.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def artefact_params
      params.require(:artefact).permit(:name, :task_id)
    end
end

app/helpers/artefacts_helper.rb
module ArtefactsHelper
end

app/views/artefacts/_form.html.erb
<%= form_for(artefact) do |f| %>
  <% if artefact.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(artefact.errors.count, "error") %> prohibited this artefact from being saved:</h2>

      <ul>
      <% artefact.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :name %>
    <%= f.text_field :name %>
  </div>

  <div class="field">
    <%= f.label :task_id %>
    <%= f.number_field :task_id %>
  </div>

  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/artefacts/edit.html.erb
<h1>Editing Artefact</h1>

<%= render 'form', artefact: @artefact %>

<%= link_to 'Show', @artefact %> |
<%= link_to 'Back', artefacts_path %>

app/views/artefacts/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Artefacts</h1>
<%= link_to 'New Artefact', new_artefact_path %>
<table class="table table-bordered">
  <thead>
    <tr>
      <th>Name</th>
      <th>Activity</th>
      <th>Process</th>
      <th>Original Id</td>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @artefacts.each do |artefact| %>
      <tr>
        <td><%= link_to artefact.name, artefact %></td>
        <td><%= artefact.task.name %></td>
        <td><%= artefact.task.bpmn_process.name %></td>
        <td><%= artefact.original_id %></td>
        <td><%= link_to 'Destroy', artefact, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

app/views/artefacts/new.html.erb
<h1>New Artefact</h1>

<%= render 'form', artefact: @artefact %>

<%= link_to 'Back', artefacts_path %>

app/views/artefacts/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Name:</strong>
  <%= @artefact.name %>
</p>

<p>
  <strong>Task:</strong>
  <%= @artefact.task.name %>
</p>

<%= link_to 'Edit', edit_artefact_path(@artefact) %> |
<%= link_to 'Back', artefacts_path %>